clc
clear all

%%%%%%%%%% Section 5.1 %%%%%%%%%%

% Table 1 (Also imports the data from the DellaVigna and Pope experiments into Matlab and saves it in .mat format)
Table1 = ImportDPdata;
writematrix(Table1,'../Table1.txt','Delimiter',' ')

% Figure 1
Predict_Performance(0.3,1);

% Table 2
RHO = [0 0.1 0.2 0.3 0.4 0.5 1];
for i=1:7
    Table2(:,i) = [RHO(i) ; -1 ; round(Predict_Performance(RHO(i),0),2)];
end
writematrix(Table2,'../Table2.txt','Delimiter',' ')

%%%%%%%%%% Section 5.2 %%%%%%%%%%

% Table 3
Table3 = Estimate_parameters(0.3,1); Table3 = Table3([2 1 3]);
writematrix(Table3,'../Table3.txt','Delimiter',' ')

% Figures 2-3, Figures 6-7 and Tables 4-5
[ParametersList, Table_homogeneous, Table_hybrid] = OptAdjustments_AB(1, 1);

Table4 = [ParametersList ; -1.*ones(1,7) ; Table_homogeneous];
Table5 = [ParametersList ; -1.*ones(1,7) ; Table_hybrid];
writematrix(Table4,'../Table4.txt','Delimiter',' ')
writematrix(Table5,'../Table5.txt','Delimiter',' ')

%%%%%%%%%% Section 6.2 %%%%%%%%%%

% Figure 4
Heterogeneous_elasticity

% Figure 5
Heterogeneous_RRA;

%%%%%%%%%% Online Appendix A.1 %%%%%%%%%%

% Figure 6 - See line 26 above
% Figure 7 - See line 26 above

% Figure 8
Predict_Performance(0.3,3);

% Figure 9
Predict_Performance(0.3,4);

% Table 5 - See line 26 above

% Figure 10 and Table 6
[ParametersList, Table_homogeneous, Table_hybrid] = OptAdjustments_AB(100, 5);

Table6 = [ParametersList ; -1.*ones(1,7) ; Table_homogeneous ; -1.*ones(1,7) ; Table_hybrid];
writematrix(Table6,'../Table6.txt','Delimiter',' ')

%%%%%%%%%% Online Appendix A.2 %%%%%%%%%%

% Table 7, Column (II)
Table7(:,1) = [Table2([3:11],4) ; -1 ; -1 ; Table2([15:17],4)];
Table7(:,2) = round(Predict_ABC(0.3),2);
writematrix(Table7,'../Table7.txt','Delimiter',' ')

%%%%%%%%%% Online Appendix A.3 %%%%%%%%%%

% Figure 11
Predict_Manipulation;

%%%%%%%%%% Online Appendix B %%%%%%%%%%

% Table 8
Table8 = Predict_Performance_ExtraWork(0, -1);
writematrix(Table8,'../Table8.txt','Delimiter',' ')

% Figure 12
Predict_Performance_ExtraWork(0.3, 1);

% Table 9
RHO_ew = [0 0.3 0.5 1];
for i=1:4
    table = round(Predict_Performance_ExtraWork(RHO_ew(i), 0),3);
    Table9(:,i) = [RHO_ew(i) ; -1 ; table(:,1)];
    Table9(:,i+4) = [RHO_ew(i) ; -1 ; table(:,2)];
end
writematrix(Table9,'../Table9.txt','Delimiter',' ')

% Table 10 & Figure 13
Params_ew = [0.3 0.1 0.5 0.3 0.3 0.3 0.3 ; 0.3 0.3 0.3 0.1 0.5 0.3 0.3 ; 5 5 5 5 5 4 6];
for i = 1:7
    Table10(:,i) = OptAdjustments_ExtraWork(Params_ew(3,i), Params_ew(1,i), Params_ew(2,i));
end
writematrix(Table10,'../Table10.txt','Delimiter',' ')

clc