function [F, F_a, f_kernel, x, a_est, aa, a_max, A] = Density_spline;

load('DP_Data');

aa = round([mean(DP_0c) mean(DP_01c) mean(DP_1c) mean(DP_4c) mean(DP_10c) mean(DP_40c) mean(DP_80c)]'); 

% Estimate distributions using kernels
[f_0c x] = KernelEst(DP_0c);
[f_01c x] = KernelEst(DP_01c);
[f_1c x] = KernelEst(DP_1c);
[f_4c x] = KernelEst(DP_4c);
[f_10c x] = KernelEst(DP_10c);
[f_40c x] = KernelEst(DP_40c);
[f_80c x] = KernelEst(DP_80c);

k = 3; %Epanechnikov = 1 ; Biweight = 2 ; Triweight = 3 ; Gaussian = 4 (2nd degree)
f_0c = f_0c(:,k) ./trapz(x,f_0c(:,k));
f_01c = f_01c(:,k) ./trapz(x,f_01c(:,k));
f_1c = f_1c(:,k) ./trapz(x,f_1c(:,k));
f_4c = f_4c(:,k) ./trapz(x,f_4c(:,k));
f_10c = f_10c(:,k) ./trapz(x,f_10c(:,k));
f_40c = f_40c(:,k) ./trapz(x,f_40c(:,k));
f_80c = f_80c(:,k) ./trapz(x,f_80c(:,k));

a_est = round([trapz(x,x.*f_0c); trapz(x,x.*f_01c); trapz(x,x.*f_1c); trapz(x,x.*f_4c); trapz(x,x.*f_10c); trapz(x,x.*f_40c); trapz(x,x.*f_80c)]);
f_kernel = [f_0c f_01c  f_1c f_4c f_10c f_40c f_80c];
indx = [1:5];

A = [1:2300]'; % Reduced from 2200
for xx=1:length(x) 
    F(xx,:) = spline(a_est(indx), f_kernel(xx,indx), A(a_est(1)-1:end)); 
end

F = [zeros(length(x), a_est(1)-2) F];
F_a = F(:,2:end) - F(:,1:end-1);
F_a = [zeros(length(x),1) F_a];

a_max = A(min(find(min(F)<0))-1);
a_est = min(a_max, a_est);
F = F(:,1:a_max);
F_a = F_a(:,1:a_max);
A = A(1:a_max);