function params = Estimate_parameters(rho,mgnfy);

[F, F_a, f_kernel, x, a_est, aa, a_max, A] = Density_spline;

magnify = mgnfy;

wLin = @(xx,alpha) (100+alpha.*xx);
wBonus = @(xx,B) (100 + B.*(xx>2000));
WW = magnify.*[wLin(x,0) wLin(x,0.001) wLin(x,0.01) wLin(x,0.04) wLin(x,0.1) wBonus(x,40) wBonus(x,80)];

a_est = a_est(1:7);
for k=1:length(a_est)
    MI(k,1) = trapz(x,(WW(:,k).^(1-rho)).*F_a(:,a_est(k)))./(1-rho);
end
MI(1)=0; MI(2:end) = max(0, MI(2:end));

G = @(bb) ( log(a_est) - bb(1) - bb(2).*log(MI + bb(3).^2) );

opts = optimoptions(@lsqnonlin,'MaxFunctionEvaluations',10^10, 'MaxIter',10^10,'TolX',10^-40);
params = lsqnonlin(G, [7 ; 0.05 ; 10^-3],[],[],opts);

params = [params(1:2) ; params(3).^2 ; G(params)' * G(params)];

%beta = bb(1);
%eps = bb(2);
%II = bb(3).^2;