function [IR_extrap] = GenerateIR(rho, mgnfy);

[F, F_a, f_kernel, x, a_est, aa, a_max, A] = Density_spline;
U = @(om) ( (om.^(1-rho)) ./ (1-rho) );

magnify = mgnfy;

wLin = @(xx,alpha) (100+alpha.*xx);
wBonus = @(xx,B) (100 + B.*(xx>2000));
WW = mgnfy.*[wLin(x,0) wLin(x,0.001) wLin(x,0.01) wLin(x,0.04) wLin(x,0.1) wBonus(x,40) wBonus(x,80)];

% Generate all pairs of A-B tests
NN=1;
for n=2:length(aa)
    %for nn=2:length(aa)
    for nn=n+1:length(aa)
        if n ~= nn
            cnt(NN,:)=[n nn NN];
            NN = NN+1;
        end
    end
end

% Generate f_hat and f_a for each A-B test
for counter=1:15%30
    F_Hat(:,counter) = f_kernel(:,cnt(counter,1));
    F_Hat_a(:,counter) = (f_kernel(:,cnt(counter,2))-f_kernel(:,cnt(counter,1)))./ trapz(x,x.*(f_kernel(:,cnt(counter,2))-f_kernel(:,cnt(counter,1))));
end

for counter = setdiff(1:15, 13)

% Set A-B test
i = cnt(counter,1);
j = cnt(counter,2);

what = WW(:,i);
f_hat = F_Hat(:,counter);
fa_hat = F_Hat_a(:,counter);
ahat = a_est(i);

a_AB = [a_est(i) , a_est(j)];
MI = [max(0,trapz(x,U(WW(:,i)).*fa_hat)) , max(0,trapz(x,U(WW(:,j)).*fa_hat))];
eps_AB = log(a_AB(2)./a_AB(1)) ./ log(MI(2)./MI(1));
beta_AB = log(a_AB(1)) - eps_AB.*log(MI(1));
c0_AB = exp(-beta_AB/eps_AB);
p_AB = 1./eps_AB;

Data_AB(counter, 1:6) = [cnt(counter,1:2) , eps_AB , beta_AB , c0_AB , p_AB];
% Columns 1-2 are cnt; Columns 3, 4, 5, 6 are beta, eps, c0, and p, respectively

    for k=2:7
        MI_IR(counter,k) = max(0, trapz(x,U(WW(:,k)).*F_Hat_a(:,counter)));
        a_pred(counter,k) = exp(beta_AB + eps_AB.*log(MI_IR(counter,k)));
    end
    for k=2:7
        Da_pred(counter,k) = a_pred(counter,k) - a_pred(counter, cnt(counter,1));
        IR_extrap(counter,k) = trapz(x, U(WW(:,k)).*(F_Hat(:,counter) + Da_pred(counter,k).*F_Hat_a(:,counter))) - min(100,((c0_AB./(p_AB+1)).*((a_pred(counter,k)).^(p_AB+1))));
    end

end

IR_extrap = [IR_extrap cnt];
