function [Table1] = ImportDPdata;

Data_ab = readmatrix('DP_ab_task.xlsx');
Data_ew = readmatrix('DP_extrawork_task.xlsx');

DP_0c = Data_ab(find(Data_ab(:,2) == 1.3),1); % No-incentives treatment
DP_01c = Data_ab(find(Data_ab(:,2) == 2),1); % 0.001 piece-rate treatment
DP_1c = Data_ab(find(Data_ab(:,2) == 1.1),1); % 0.01 piece-rate treatment
DP_4c = Data_ab(find(Data_ab(:,2) == 1.4),1); % 0.04 piece-rate treatment
DP_10c = Data_ab(find(Data_ab(:,2) == 1.2),1); % 0.1 piece-rate treatment
DP_40c = Data_ab(find(Data_ab(:,2) == 5.1),1); % 40-cent bonus treatment
DP_80c = Data_ab(find(Data_ab(:,2) == 5.3),1); % 80-cent bonus treatment

Table1(1,:) = [mean(DP_0c) std(DP_0c) length(DP_0c)];
Table1(2,:) = [mean(DP_01c) std(DP_01c) length(DP_01c)];
Table1(3,:) = [mean(DP_1c) std(DP_1c) length(DP_1c)];
Table1(4,:) = [mean(DP_4c) std(DP_4c) length(DP_4c)];
Table1(5,:) = [mean(DP_10c) std(DP_10c) length(DP_10c)];
Table1(6,:) = [mean(DP_40c) std(DP_40c) length(DP_40c)];
Table1(7,:) = [mean(DP_80c) std(DP_80c) length(DP_80c)];

Table1 = round(Table1);

% Remove entries with >3500 points (see Footnote 11)
DP_0c = DP_0c(find(DP_0c<3500));
DP_01c = DP_01c(find(DP_01c<3500)); 
DP_1c = DP_1c(find(DP_1c<3500)); 
DP_4c = DP_4c(find(DP_4c<3500));  
DP_10c = DP_10c(find(DP_10c<3500)); 
DP_40c = DP_40c(find(DP_40c<3500)); 
DP_80c = DP_80c(find(DP_80c<3500)); 

Data_ew = Data_ew(find(Data_ew(:,2)==3),:);
DP_extra_alpha0c = Data_ew(find(Data_ew(:,1)==11),3);
DP_extra_alpha01c = Data_ew(find(Data_ew(:,1)==20),3);
DP_extra_alpha1c = Data_ew(find(Data_ew(:,1)==12),3);
DP_extra_alpha4c = Data_ew(find(Data_ew(:,1)==13),3);
DP_extra_alpha10c = Data_ew(find(Data_ew(:,1)==14),3);

save DP_Data.mat DP_0c DP_01c DP_1c DP_4c DP_10c DP_40c DP_80c
save DP_Data_ExtraWork.mat DP_extra_alpha0c DP_extra_alpha01c DP_extra_alpha1c DP_extra_alpha4c DP_extra_alpha10c