function [f x] = KernelEst(data)

% Hansen, B.E., 2009. Lecture notes on nonparametrics. Lecture notes.

% Kernel: Epanechnikov = 1 ; Biweight = 2 ; Triweight = 3 ; Gaussian = 4 (2nd degree)
% load('DP_Data')

k1 = @(u) ((3/4).*(1-u.^2).*(abs(u)<=1));
k2 = @(u) ((15/16).*((1-u.^2).^2).*(abs(u)<=1));
k3 = @(u) ((35/32).*((1-u.^2).^3).*(abs(u)<=1));
kphi = @(u) (exp(-(u.^2)./2) ./ sqrt(2.*pi));

% Derivatives (not used currently)
k1_d = @(u) ((-3/2).*u.*(abs(u)<=1));
k2_d = @(u) ((-15/4).*u.*(1-u.^2).*(abs(u)<=1));
k3_d = @(u) ((-105/16).*u.*((1-u.^2).^2).*(abs(u)<=1));
kphi_d = @(u) ((-u.*exp(-(u.^2)./2))./sqrt(2.*pi));

% Silverman Rule-of-Thumb Constant and bandwidth
sigma = std(data);
n = length(data);

C = [2.34 0 ; 2.78 2.49 ; 3.15 2.83 ; 1.06 0.97];
h = @(kernel,diff) ( C(kernel,diff) * sigma * (n^(-1/(5 + (diff==2)))) );
H = [h(1,1) 0 ; h(2,1) h(2,2) ; h(3,1) h(3,2) ; h(4,1) h(4,2)]; % bandwidth

% Compute

x_min = 0;
x_max = 3500;
I = x_max + abs(x_min) + 1;
%x_min = -2000;
%x_max = 2000;
x = linspace(x_min,x_max,I)';

for i=1:I
    f(i,1) = sum(k1((x(i)-data)./H(1,1))) ./ (n.*H(1,1));
    f(i,2) = sum(k1((x(i)-data)./H(2,1))) ./ (n.*H(2,1));
    f(i,3) = sum(k1((x(i)-data)./H(3,1))) ./ (n.*H(3,1));
    f(i,4) = sum(k1((x(i)-data)./H(4,1))) ./ (n.*H(4,1));
end

%[f x] = KernelEst(DP_01c);