function [SumStat] = Predict_Manipulation;

load('DP_Data')
k = 3;
[f_0c x] = KernelEst(DP_0c); f_0c = f_0c(:,k) ./trapz(x,f_0c(:,k));
[f_01c x] = KernelEst(DP_01c); f_01c = f_01c(:,k) ./trapz(x,f_01c(:,k));
[f_1c x] = KernelEst(DP_1c); f_1c = f_1c(:,k) ./trapz(x,f_1c(:,k));
[f_4c x] = KernelEst(DP_4c); f_4c = f_4c(:,k) ./trapz(x,f_4c(:,k));
[f_10c x] = KernelEst(DP_10c); f_10c = f_10c(:,k) ./trapz(x,f_10c(:,k));
[f_40c x] = KernelEst(DP_40c); f_40c = f_40c(:,k) ./trapz(x,f_40c(:,k));
[f_80c x] = KernelEst(DP_80c); f_80c = f_80c(:,k) ./trapz(x,f_80c(:,k));

A = [mean(DP_0c) mean(DP_01c) mean(DP_1c) mean(DP_4c) mean(DP_10c) mean(DP_40c) mean(DP_80c)];
FF = [f_0c f_01c f_1c f_4c f_10c f_40c f_80c];

rho = 0; 
U = @(om) ( (om.^(1-rho)) / (1-rho) );

wLin = @(xx,alpha) (100+alpha.*xx);
wBonus = @(xx,B) (100 + B.*(xx>2000));
WW = [U(wLin(x,0)) U(wLin(x,0.001)) U(wLin(x,0.01)) U(wLin(x,0.04)) U(wLin(x,0.1)) U(wBonus(x,40)) U(wBonus(x,80))];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

NN=1;
for i=2:4
    for j=i+1:5
        for k=6:7
            cnt(NN,:)=[i j k];
            NN=NN+1;
        end
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for counter = 1:length(cnt)

i = cnt(counter,1);
j = cnt(counter,2); 
k = cnt(counter,3); % k = 6 or 7
kk = [6 7]; kk(find(kk==k))=[];
    
    for xi=1:length(x)
        x_ols = [ones(3,1) [A(i);A(j);A(k)]] \ [FF(xi,i);FF(xi,j);FF(xi,k)];
        g(xi,1) = x_ols(1);
        h(xi,1) = x_ols(2);
    end

for l=1:7
    MI(l) = max(0, trapz(x,WW(:,l).*h)) ;
end
eps = log(A(i)./A(j)) ./ log((MI(i))./(MI(j)));
beta = log(A(i)) - eps.*log(MI(i));

c = @(a) ((eps./(1+eps)).*(exp(-beta./eps)).*(a.^((1+eps)./eps)));

Summary(counter,1:4) = [i j k kk];
Summary(counter,5) = A(kk);
Summary(counter,6) = exp(beta + eps.*log(MI(kk)));
Summary(counter,7) = 100.*abs((Summary(counter,6)-A(kk))./A(kk)); % APE for simple estimation

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

f_base = g + A(k).*h;
N = length(x); Dx = x(2)-x(1);

kmin = 5; kmax = 6; 

optim = 1; % 1 for "quick" algorithm ; 2 for line-search

if optim == 1

tol = 10^-2; 
    
f_manp(:,1) = Manipulation_agent(kmin, N, x, f_base, A(k), WW(:,k));
f_manp(:,2) = Manipulation_agent(kmax, N, x, f_base, A(k), WW(:,k));

Table(1,:) = [kmin trapz(x, (f_manp(:,1)-FF(:,k)).^2)];
Table(2,:) = [kmax trapz(x, (f_manp(:,2)-FF(:,k)).^2)];
l = 2;

while (kmax-kmin > tol) && l < 100
    
kmid1 = kmin + (kmax-kmin)/3;
kmid2 = kmin + 2*(kmax-kmin)/3;

f_manp(:,l+1) = Manipulation_agent(kmid1, N, x, f_base, A(k), WW(:,k));
f_manp(:,l+2) = Manipulation_agent(kmid2, N, x, f_base, A(k), WW(:,k));

Table(l+1,:) = [kmid1 trapz(x, (f_manp(:,l+1)-FF(:,k)).^2)];
Table(l+2,:) = [kmid2 trapz(x, (f_manp(:,l+2)-FF(:,k)).^2)];

if trapz(x, (f_manp(:,l+1)-FF(:,k)).^2) < trapz(x, (f_manp(:,l+2)-FF(:,k)).^2)
    kmax = kmid2;
else
    kmin = kmid1;
end
l = l+2;

end
clearvars Table f_manp

kappa = kmin + (kmax-kmin)/2;

elseif optim == 2
    
kappa_vec = linspace(kmin, kmax, 101);

for k_ind = 1:length(kappa_vec)
    
    f_manp(:,k_ind) = Manipulation_agent(kappa_vec(k_ind), N, x, f_base, A(k), WW(:,k));
    Table(k_ind,:,counter) = [kappa_vec(k_ind) trapz(x, (f_manp(:,k_ind)-FF(:,k)).^2)];
    
end

kappa = kappa_vec(find(Table(:,2,counter)==min(Table(:,2,counter))));

clearvars f_manp
    
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

aa = [2000:2:2200];
for l = 1:length(aa)  
    
f_agent(:,l) = Manipulation_agent(kappa, N, x, g+aa(l).*h, aa(l), WW(:,kk));
Agent_payoff(l,1) = Dx.*sum(WW(:,kk).*f_agent(:,l) - (10^kappa).*(((f_agent(:,l)-(g + aa(l).*h))).^2)) - c(aa(l));

end
 
[MaxPayoff a_ind] = max(Agent_payoff); 

f_manipulate(:,1,counter) = FF(:,kk);
f_manipulate(:,2,counter) = f_agent(:,a_ind);
f_manipulate(:,3,counter) = g + aa(a_ind).*h;

Summary(counter,8) = aa(a_ind);
Summary(counter,9) = 100.*abs((Summary(counter,8)-A(kk))./A(kk)); % APE for smart estimation
Summary(counter,10) = kappa;

end

% Column (1,1) reports the mean APE using the baseline model
% Column (2,1) reports the worst-case APE using the baseline model
% Column (2,1) reports the mean APE using the model in Appendix A.3
% Column (2,2) reports the worst-case APE using the model in Appendix A.3
SumStat = [mean(Summary(:,7)) mean(Summary(:,9)) ; max(Summary(:,7)) max(Summary(:,9))];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for i1 = 1:3
    for i2 = 1:12
        for xx=1:3500
            F_manipulate(xx+1,i1,i2) = trapz(x(1:xx+1), f_manipulate(1:xx+1,i1,i2));
        end
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%

    figure('Name','Figure 11: Multitasking with distribution manipulation','NumberTitle','off','units','normalized','outerposition',[0 0 1 1])
    set(0,'defaultTextInterpreter','latex');
    
    subplot(1,2,1); plot(x, FF(:,[5 7]), 'linewidth',3)
    xlabel('$x$','FontSize',20); ylabel('Estimated probability density function $\widehat{f}^k(x)$','FontSize',20);
    legend('$k=5$', '$k=7$','interpreter','latex','Location','northwest','FontSize',20);
    legend('boxoff')
    
    subplot(1,2,2); plot(x, f_manipulate(:,1,11), 'r', 'linewidth',3); hold on
    plot(x, f_manipulate(:,2,11), ':g', 'linewidth',3); 
    plot(x, f_manipulate(:,3,11), '--b', 'linewidth',3); hold off
    xlabel('$x$','FontSize',20); ylabel('Probability density function','FontSize',20);
    legend('$\widehat{f}^7(x)$', '$\widetilde{f}^{456}_7(x;\kappa^*)$', '$\widetilde{f}^{456}_7(x;\infty)$','interpreter','latex','Location','northwest','FontSize',20);
    legend('boxoff')
    
    fig = gcf;
    fig.Color = 'w';
    saveas(gcf,'../Figure11.png')
    